
uses Objects, Drivers, Views, Menus, App, GadGets, Dialogs, Fields, PXBrowse,
     OOPXENG, BGENC, StdDlg, BGENH;

const cmOpen = 101;

var str: string;

type
  TWorkApp = object(TApplication)
    Clock  : PClockView;
    Heap   : PHeapView;
    P      : PBrowseWin;
    constructor Init;
    procedure Idle; virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure InitMenuBar; virtual;
    procedure InitStatusLine; virtual;
  end;

{ TMyApp }

 constructor TWorkApp.Init;
  var
   R: TRect;
  begin
   TApplication.Init;
   GetExtent(R);
   R.A.X := R.B.X - 9; R.B.Y := R.A.Y + 1;
   Clock := New(PClockView, Init(R));
   Insert(Clock);
   GetExtent(R);
   R.A.X := R.B.X - 20; R.B.X:=R.B.X - 11;
   R.B.Y := R.A.Y + 1;
   Heap := New(PHeapView, Init(R));
   Insert(Heap);
   DeskTop^.GetExtent(R);
   if ParamCount = 1 then
    begin
     str:=ParamStr(1);
     P:=New(PBrowseWin, Init(R, str, str));
     DeskTop^.Insert(P);
    end;
  end;

 procedure TWorkApp.Idle;
  begin
   TApplication.Idle;
   Clock^.Update;
   Heap^.Update;
  end;

 procedure TWorkApp.HandleEvent(var Event: TEvent);
  var
   D: PFileDialog;
   R: TRect;
  begin
   TApplication.HandleEvent(Event);
   if Event.What = evCommand then
    if Event.Command = cmOpen then
     begin
      New(D, Init('*.DB', 'Browse', '~T~able', fdOpenButton, 101));
      if DeskTop^.ExecView(D) <> cmCancel then
       begin
        D^.GetData(str);
        DeskTop^.getExtent(R);
        DeskTop^.Insert(New(PBrowseWin, Init(R, str, str)));
       end;
      Dispose(D, Done);
     end;
  end;

 procedure TWorkApp.InitMenuBar;
  var R: TRect;
  begin
   GetExtent(R);
   R.B.Y := R.A.Y + 1;
   MenuBar := New(PMenuBar, Init(R, NewMenu(
    NewSubMenu('', hcNoContext, NewMenu(
     NewItem('',            '', kbNoKey,  cmOk, hcNoContext,
     NewLine(
     NewItem('E~x~it', 'Alt-X', kbAltX, cmQuit, hcNoContext, nil)))), nil))));
  end;

 procedure TWorkApp.InitStatusLine;
  var R: TRect;
  begin
   GetExtent(R);
   R.A.Y := R.B.Y - 1;
   StatusLine := New(PStatusLine, Init(R,
    NewStatusDef(0, hcBrowser,
      NewStatusKey('~Ins~-new ',   kbIns, cmInsRec,
      NewStatusKey('~E~dit',       kbAltE, cmEditRec,
      NewStatusKey('~Del~',        kbDel, cmDelRec,
      NewStatusKey('',             kbAltF3,  cmClose,
      NewStatusKey('',             kbF5,  cmZoom,
      NewStatusKey('',             kbCtrlF5,  cmResize,
      NewStatusKey('Prev',         kbF6,     cmNext,
      NewStatusKey('Next',         kbShiftF6, cmPrev,
      NewStatusKey('~F3~-Open',    kbF3,  cmOpen,
      NewStatusKey('~F10~ Menu',   kbF10, cmMenu,
      NewStatusKey('~Alt-X~ Exit', kbAltX,  cmQuit,
      nil))))))))))),
    NewStatusDef(hcBEditor, hcBEditor,
      NewStatusKey('~F2~ Save', kbF2, cmSave,
      NewStatusKey('~F3~ Prev', kbF3, cmRPrev,
      NewStatusKey('~F4~ Next', kbF4, cmRNext,
      NewStatusKey('~Ok~',      kbEnter, cmOk,
      NewStatusKey('~Cancel~',  kbEsc, cmCancel,
      NewStatusKey('',          kbCtrlF5, cmResize,
      nil)))))),
    nil))));
  end;

var
  WorkApp: TWorkApp;

begin
  Eng.defInit(pxLocal);
  DB.Init(@Eng);
  Eng.setTblCreateMode(px35Fmt);
  WorkApp.Init;
  WorkApp.Run;
  WorkApp.Done;
  DB.Done;
  Eng.Done;
end.
